// RegisterClass.h: CRegisterClass 's Interface
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_REGISTERCLASS_H__F43F863A_0643_11D2_8447_00A02491B6C9__INCLUDED_)
#define AFX_REGISTERCLASS_H__F43F863A_0643_11D2_8447_00A02491B6C9__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <winreg.h>

class CRegisterClass  
{
public:
	BOOL RemoveKey(LPCTSTR key);
	BOOL DelRegKey(LPCTSTR lpszKey,LPCTSTR lpszValueName=NULL);
	BOOL SetRegKey(LPCTSTR lpszKey,LPCTSTR lpszValue,LPCTSTR lpszValueName=NULL);
	BOOL Register(BOOL bRegister=TRUE);
	int AddSymbolAlias(LPCTSTR symbol,LPCTSTR alias);
	int AddSymbol(LPCTSTR symbol);
	void AddEntry(LPCTSTR key,LPCTSTR value,LPCTSTR valueName=NULL);
	CRegisterClass(REFCLSID clsid,LPCTSTR pszTypeName,HKEY hKeyRoot = HKEY_CLASSES_ROOT);
	virtual ~CRegisterClass();

protected:
	BOOL Helper(BOOL bRegister,LPCTSTR const*ppSymbols,int nSymbols);
	
	HKEY m_hKeyRoot;
	CStringArray	m_keys;
	CStringArray	m_values;
	CStringArray	m_valueNames;
	CStringArray	m_symbols;
};

#endif // !defined(AFX_REGISTERCLASS_H__F43F863A_0643_11D2_8447_00A02491B6C9__INCLUDED_)
